/*
  4:  
     Oxy      A  -
   N < 20  .  A      -
  .          
    ,     ,     5
 ,           
   ,      A.
 :
    .  ,     , 
  ,     .
 1.             .
  ,     ,    ,
     .     ,   
   ,          
  ,    ,      
   ,        .
 2.          
   O( 0, 0 )  A,  (      ,)
 -   -.    ,
 X * x + Y * y = 0 (X, Y - const      -  
  )    :
     ( X   Y  1 )
 M = (a.x a.y 1 )
     ( 0   0  1 )
           -,  d(M) = 0
 <=> X * a.x + Y * a.y = 0
      X  Y,    
 Y * vector[i].x - X * vector[i].y,   i,     .
           ,  
 ,    .
  ,       -    -
    ,          .
*/

#include <stdio.h>
#include <stdlib.h>

#define MAX 20

typedef struct { long x, y; } VECTOR;

#define abs( x ) ( x < 0 ? -1 : x > 0 )

VECTOR a = { 5000, 5000 }; //  
VECTOR vector[] = {{ -1000, -1000 }, { 1000, 1000 }};  //  
VECTOR pos;  //  
int n = 2;
int count[MAX];  //        

int cmpfn( void *x1, void *x2 )  //    qsort()
{
  VECTOR v1, v2;

  v1 = *(VECTOR*)x1;
  v2 = *(VECTOR*)x2;

  return ( v2.y - v1.y ) * a.x - ( v2.x - v1.x ) * a.y;
}

add( int curr )
{
  long i, j;

  if(( !a.x || !( i = vector[curr].x + pos.x ) || abs( a.x ) == abs( i ) )
   &&( !a.y || !( j = vector[curr].y + pos.y ) || abs( a.y ) == abs( j ) ))
  {
    pos.x = i, pos.y = j,
    count[curr]++;
    if( pos.x == a.x && pos.y == a.y )
    {
      for( i = j = 0; i < n; i++ )
        if( count[i] ) j++;
      printf( "%d", j );
      for( i = 0; i < n; i++ )
        if( count[i] )
          printf( "\n%.f %.f %d",
             (float)vector[i].x / 1000, (float)vector[i].y / 1000, count[i] );
      exit( 0 );
    }
    for( i = 0; i < n; i++ )
      if( count[i] < 5 ) add( i );
    pos.x -= vector[curr].x, pos.y -= vector[curr].y,
    count[curr]--;
  }
}

main()
{
  int i;

  qsort( vector, n, sizeof( VECTOR ), cmpfn );

  for( i = 0; i < n; i++ )
    add( i );

  printf( "0" );
}
